# $Id: OpenGL.m4,v 1.10 2003/06/19 14:43:32 erik Exp $
#
# stolen from 'famp' at http://famp.sourceforge.net (google told me to)
# AC_SUBST's both GL_CFLAGS and GL_LIBS, and sets have_GL
#
# oct 26, 2000 
# * Changed CONFIGURE_OPENGL to AM_PATH_OPENGL for consistancy
# -Erik Greenwald <erik@smluc.org>


#
# AM_PATH_OPENGL([ACTION-IF-FOUND [,ACTION-IF-NOT-FOUND]])
#

AC_DEFUN(AM_PATH_OPENGL,
[
  AC_REQUIRE([AC_PROG_CC])

dnl I think this should be target for cross compilers, but krissa's busted
dnl install pukes on that. The things I do for pretty girls *sigh*
case $host in
	*-*-cygwin* | *-*-mingw*)
		;;
	*)
		# X and X-extra not needed for cyggy stuff
		AC_REQUIRE([AC_PATH_X])
		AC_REQUIRE([AC_PATH_XTRA])
		;;
esac

  GL_CFLAGS=""
  GL_LIBS=""

  GLXEXTRALIBSHIT="-lX11 -lXext -lXmu -lXt -lXi"

  AC_LANG_SAVE
  AC_LANG_C

  if ! test x"$no_x" = xyes; then
    GL_CFLAGS="$X_CFLAGS"
    GL_X_LIBS="$X_PRE_LIBS $X_LIBS $GLXEXTRALIBSHIT $X_EXTRA_LIBS $LIBM"
  fi

  AC_ARG_WITH(gl-prefix,    
    [  --with-gl-prefix=PFX     Prefix where OpenGL is installed],
    [
      GL_CFLAGS="-I$withval/include"
      GL_LIBS="-L$withval/lib"
    ])

  AC_ARG_WITH(gl-includes,    
    [  --with-gl-includes=DIR   where the OpenGL includes are installed],
    [
      GL_CFLAGS="-I$withval"
    ])

  AC_ARG_WITH(gl-libraries,    
    [  --with-gl-libraries=DIR  where the OpenGL libraries are installed],
    [
      GL_LIBS="-L$withval"
    ])

  saved_CFLAGS="$CFLAGS"
  saved_LIBS="$LIBS"
  AC_LANG_SAVE
  AC_LANG_C
  have_GL=no

  exec 8>&AC_FD_MSG
dnl  exec AC_FD_MSG>/dev/null

dnl windows is fucking retarded. It can't cope with searchlib because of
dnl stupid WINGDAPI APIENTRY crap. :( So we punt.
dnl Also, Mrs Krissa had an issue with -I/usr/X11R6/include showing up on
dnl her compile line and pharking things up for link phase, so we clear that.
case "$host" in
	*-*-cygwin* | *-*-mingw32*)
		GL_CFLAGS=""
		GL_LIBS="-lopengl32"
		have_GL=yes
		;;
	*-apple-darwin*)
		GL_LIBS="-framework GLUT -framework OpenGL -framework Carbon -lobjc"
		have_GL=yes
		;;
	*)
		AC_SEARCH_LIBS(glFrustum,
			[GL MesaGL Mesa3d opengl opengl32],
			[
				have_GL=yes
				GL_LIBS="$LIBS"
			],
			AC_ERROR(Need OpenGL),
			$GL_LIBS $GL_X_LIBS)
		;;
esac

  LIBS="$saved_LIBS"
  CFLAGS="$saved_CFLAGS"

  exec AC_FD_MSG>&8
  AC_LANG_RESTORE

  if test "$have_GL" = "yes"; then
     ifelse([$1], , :, [$1])     
  else
     GL_CFLAGS=""
     GL_LIBS=""
     ifelse([$2], , :, [$2])
  fi
  AC_SUBST(GL_CFLAGS)
  AC_SUBST(GL_LIBS)
])

